#ifndef BAREPARTICLE_SEEN
#define BAREPARTICLE_SEEN

#include <iostream>
#include <sstream>

#include <cmath>


#include "mathematicalTools.h"

using namespace std;

class bareParticle 
{

 protected:

  TRIDVECTOR position_;  // cm
  TRIDVECTOR betagamma_;  // radians
  double gamma_;



 protected:




 public :

  bareParticle() {;}

~bareParticle() {;}


 bareParticle(const TRIDVECTOR&  pos , const TRIDVECTOR& bg);

 bareParticle(bareParticle& bp);

 bareParticle(const bareParticle& bp);
 
 void resetDynamics(const bareParticle& bp);

 bareParticle& operator = (const bareParticle& bp);


 const TRIDVECTOR& getReferenceToPosition() const;

 TRIDVECTOR getPosition() const;

 TRIDVECTOR& getReferenceToPosition(); 

 double getZ() const;


 void setZ(double z);

 void incrementZ( double dz);

 void setX(double x); 


 double getRadius() const;


 TRIDVECTOR getBetaGamma() const;


 TRIDVECTOR& getReferenceToBetaGamma(); 
 
 void setBetaGamma(const TRIDVECTOR& btg); 

 double getBetaz() const;


 double getGamma() const; 


 void imprimer() const; 


 string FileOutputFlow() const;

 virtual bool FileInput( ifstream& ifs);


};
#endif
