#include <iostream>

#include <Wt/WCssDecorationStyle>
#include <Wt/WApplication>

#include "GWt_dropZoneLigneFaisceau.h"
#include "GWt_ligneFaisceau.h"
#include "GWt_console.h"
#include "nomdElements.h"

GWt_dropZoneLigneFaisceau::GWt_dropZoneLigneFaisceau( PspaApplication* pspa)
  : WContainerWidget()
{
  initialise(pspa);
}

GWt_dropZoneLigneFaisceau::~GWt_dropZoneLigneFaisceau()
{
}

void GWt_dropZoneLigneFaisceau::initialise( PspaApplication* pspa)
{
  
  // connect mouse events
  mouseWentOver().connect(this, &GWt_dropZoneLigneFaisceau::mouseOver);
  mouseWentUp().connect(this, &GWt_dropZoneLigneFaisceau::mouseUp);
  mouseWentDown().connect(this, &GWt_dropZoneLigneFaisceau::mouseDown);
  mouseWentOut().connect(this, &GWt_dropZoneLigneFaisceau::mouseOut);
  mouseDragged().connect(this, &GWt_dropZoneLigneFaisceau::mouseIsDragged);
  
  // accept drops
  vector <GWt_abstractElement*> elems = pspa->getAbstractElementFactory()->getAllElements();
  for(int a = 0; a < elems.size(); a++) {
    acceptDrops(elems[a]->getMimeType());
  }
  setMinimumSize(10,32);
}

void GWt_dropZoneLigneFaisceau::mouseOver(const WMouseEvent& e)
{
}

void GWt_dropZoneLigneFaisceau::mouseOut(const WMouseEvent& e)
{
  decorationStyle().setCursor(ArrowCursor);
}

void GWt_dropZoneLigneFaisceau::mouseIsDragged(const WMouseEvent& e)
{
  decorationStyle().setCursor(OpenHandCursor);
}

void GWt_dropZoneLigneFaisceau::mouseUp(const WMouseEvent& e)
{
}

void GWt_dropZoneLigneFaisceau::mouseDown(const WMouseEvent& e)
{
}

void GWt_dropZoneLigneFaisceau::dropEvent(WDropEvent evt)
{
  // get LigneFaiseau widget and add new elementLigneFaiseau
  GWt_LigneFaisceau* ligneFaisceau = NULL;
  if ( static_cast<GWt_LigneFaisceau*> (wApp->findWidget ("ligneFaisceau"))) {
    ligneFaisceau = static_cast<GWt_LigneFaisceau*> (wApp->findWidget ("ligneFaisceau"));
  } else {
    return;
  }
  
  // get the type of element
  nomdElements e(evt.mimeType());
  nomdElements::typedElement eType = e.getElementType();
  ligneFaisceau->addElement(eType, this);
}


